>From 3ee5fbe2358e29e9f3c662d3953fca3f95cefa2c Mon Sep 17 00:00:00 2001
From: Jan Cholasta <jcholast@redhat.com>
Date: Mon, 12 Nov 2012 13:00:45 -0500
Subject: [PATCH 2/2] Fix errors reported by rpmlint

---
 contrib/sssd.spec.in                         | 9 ++++-----
 src/config/SSSDConfig/ipachangeconf.py       | 3 +--
 src/config/SSSDConfig/sssd_upgrade_config.py | 1 -
 src/sss_client/common.c                      | 5 ++---
 src/sss_client/nss_group.c                   | 5 ++---
 src/sss_client/nss_mc.h                      | 5 ++---
 src/sss_client/nss_mc_common.c               | 5 ++---
 src/sss_client/nss_mc_group.c                | 5 ++---
 src/sss_client/nss_mc_passwd.c               | 5 ++---
 src/sss_client/nss_passwd.c                  | 5 ++---
 10 files changed, 19 insertions(+), 29 deletions(-)

diff --git a/contrib/sssd.spec.in b/contrib/sssd.spec.in
index f9ab43b..b6bfea6 100644
--- a/contrib/sssd.spec.in
+++ b/contrib/sssd.spec.in
@@ -35,7 +35,7 @@
 %global enable_experimental 1
 
 %if (0%{?enable_experimental} == 1)
-%global experimental --enable-all-experimental-features
+    %global experimental --enable-all-experimental-features
 %endif
 
 # Determine the location of the LDB modules directory
@@ -62,7 +62,6 @@ Requires: sssd-client%{?_isa} = %{version}-%{release}
 Requires: libipa_hbac = %{version}-%{release}
 Requires: libsss_idmap = %{version}-%{release}
 Requires: cyrus-sasl-gssapi
-Requires: keyutils-libs
 %if (0%{?use_systemd} == 1)
 Requires(post): systemd-units systemd-sysv
 Requires(preun): systemd-units
@@ -265,9 +264,9 @@ autoreconf -ivf
     --enable-pammoddir=/%{_lib}/security \
     --disable-static \
     --disable-rpath \
-    %{with_ccache} \
+    %{?with_ccache} \
     %{with_initscript} \
-    %{experimental}
+    %{?experimental}
 
 make %{?_smp_mflags} all
 
@@ -341,7 +340,7 @@ do
     esac
 done
 
-# Old versions of rpmbuild require %ghost files to be present in the buildroot
+# Old versions of rpmbuild require ghost files to be present in the buildroot
 mkdir -p $RPM_BUILD_ROOT/%{mcpath}
 touch $RPM_BUILD_ROOT/%{mcpath}/passwd
 touch $RPM_BUILD_ROOT/%{mcpath}/group
diff --git a/src/config/SSSDConfig/ipachangeconf.py b/src/config/SSSDConfig/ipachangeconf.py
index ea73a9b..49394f2 100644
--- a/src/config/SSSDConfig/ipachangeconf.py
+++ b/src/config/SSSDConfig/ipachangeconf.py
@@ -14,8 +14,7 @@
 # General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 
 import fcntl
diff --git a/src/config/SSSDConfig/sssd_upgrade_config.py b/src/config/SSSDConfig/sssd_upgrade_config.py
index e05226e..7e4cbbf 100644
--- a/src/config/SSSDConfig/sssd_upgrade_config.py
+++ b/src/config/SSSDConfig/sssd_upgrade_config.py
@@ -1,4 +1,3 @@
-#!/usr/bin/python
 #coding=utf-8
 
 #  SSSD
diff --git a/src/sss_client/common.c b/src/sss_client/common.c
index 7cfa3e0..6639ae1 100644
--- a/src/sss_client/common.c
+++ b/src/sss_client/common.c
@@ -18,9 +18,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 #include "config.h"
diff --git a/src/sss_client/nss_group.c b/src/sss_client/nss_group.c
index 99b7ad9..e6ea54b 100644
--- a/src/sss_client/nss_group.c
+++ b/src/sss_client/nss_group.c
@@ -13,9 +13,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 /* GROUP database NSS interface */
diff --git a/src/sss_client/nss_mc.h b/src/sss_client/nss_mc.h
index d8155b0..f3abaab 100644
--- a/src/sss_client/nss_mc.h
+++ b/src/sss_client/nss_mc.h
@@ -13,9 +13,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 /* NSS interfaces to mmap cache */
diff --git a/src/sss_client/nss_mc_common.c b/src/sss_client/nss_mc_common.c
index 400042e..39a00f8 100644
--- a/src/sss_client/nss_mc_common.c
+++ b/src/sss_client/nss_mc_common.c
@@ -13,9 +13,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 /* NSS interfaces to mmap cache */
diff --git a/src/sss_client/nss_mc_group.c b/src/sss_client/nss_mc_group.c
index 7beeb28..b3e9a8a 100644
--- a/src/sss_client/nss_mc_group.c
+++ b/src/sss_client/nss_mc_group.c
@@ -13,9 +13,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 /* GROUP database NSS interface using mmap cache */
diff --git a/src/sss_client/nss_mc_passwd.c b/src/sss_client/nss_mc_passwd.c
index ca9945e..4acc642 100644
--- a/src/sss_client/nss_mc_passwd.c
+++ b/src/sss_client/nss_mc_passwd.c
@@ -13,9 +13,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 /* PASSWD database NSS interface using mmap cache */
diff --git a/src/sss_client/nss_passwd.c b/src/sss_client/nss_passwd.c
index e2f488b..2b349c9 100644
--- a/src/sss_client/nss_passwd.c
+++ b/src/sss_client/nss_passwd.c
@@ -13,9 +13,8 @@
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public License for more details.
  *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
 /* PASSWD database NSS interface */
-- 
1.7.11.4